"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Router = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _merge2 = _interopRequireDefault(require("lodash/merge"));

var _cloneDeep2 = _interopRequireDefault(require("lodash/cloneDeep"));

var _find2 = _interopRequireDefault(require("lodash/find"));

var _invariant = _interopRequireDefault(require("invariant"));

var _webinyCompose = _interopRequireDefault(require("webiny-compose"));

var _debug = _interopRequireDefault(require("debug"));

var _pathToRegexp = _interopRequireDefault(require("path-to-regexp"));

var _queryString = _interopRequireDefault(require("query-string"));

var _history = require("history");

var _matchPath = _interopRequireDefault(require("./utils/matchPath"));

var _generatePath = _interopRequireDefault(require("./utils/generatePath"));

var _sortRoutes = _interopRequireDefault(require("./utils/sortRoutes"));

var _parseBoolean = _interopRequireDefault(require("./utils/parseBoolean"));

var debug = (0, _debug.default)("webiny-react-router");

var Router =
/*#__PURE__*/
function () {
  function Router() {
    (0, _classCallCheck2.default)(this, Router);
    (0, _defineProperty2.default)(this, "config", void 0);
    (0, _defineProperty2.default)(this, "history", void 0);
    (0, _defineProperty2.default)(this, "middleware", void 0);
    (0, _defineProperty2.default)(this, "routes", void 0);
    (0, _defineProperty2.default)(this, "match", void 0);
    (0, _defineProperty2.default)(this, "route", void 0);
    this.routes = [];
  }

  (0, _createClass2.default)(Router, [{
    key: "configure",
    value: function configure(config) {
      this.config = (0, _objectSpread2.default)({}, config);
      this.history = config.history;
      this.middleware = (0, _webinyCompose.default)(config.middleware);

      if (!this.history) {
        this.history = (0, _history.createBrowserHistory)();
      }
    }
  }, {
    key: "addRoute",
    value: function addRoute(route) {
      route.params = [];
      (0, _pathToRegexp.default)(route.path, route.params);
      this.routes.push(route);
    }
  }, {
    key: "goToRoute",
    value: function goToRoute(options) {
      var route = options.name ? (0, _find2.default)(this.routes, {
        name: options.name
      }) : this.route;
      var params = options.merge ? (0, _objectSpread2.default)({}, this.getParams(), this.getQuery(), options.params) : options.params;
      options.name && (0, _invariant.default)(route, "Route \"".concat(options.name, "\" does not exist!"));
      var path = (0, _generatePath.default)((this.config.basename || "") + route.path, params);
      this.history.push(path);
    }
  }, {
    key: "createHref",
    value: function createHref(name, params) {
      var route = (0, _find2.default)(this.routes, {
        name: name
      });
      return (0, _generatePath.default)((this.config.basename || "") + route.path, params);
    }
  }, {
    key: "getParams",
    value: function getParams() {
      var name = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
      return name ? this.match.params[name] : this.match.params;
    }
  }, {
    key: "getQuery",
    value: function getQuery() {
      var name = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
      return name ? this.match.query[name] : this.match.query;
    }
  }, {
    key: "getRoute",
    value: function getRoute(name) {
      return (0, _find2.default)(this.routes, {
        name: name
      });
    }
  }, {
    key: "renderDefaultRoute",
    value: function () {
      var _renderDefaultRoute = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        var _this = this;

        var defaultRoute, params;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                defaultRoute = this.routes.find(function (r) {
                  return r.name === _this.config.defaultRoute;
                });

                if (!defaultRoute) {
                  _context.next = 8;
                  break;
                }

                this.route = defaultRoute;
                this.match = {
                  path: defaultRoute.path,
                  url: defaultRoute.path,
                  isExact: true,
                  params: {},
                  query: {}
                };
                params = {
                  route: defaultRoute,
                  output: null,
                  match: this.match
                };
                _context.next = 7;
                return this.middleware(params);

              case 7:
                return _context.abrupt("return", params.output);

              case 8:
                return _context.abrupt("return", null);

              case 9:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function renderDefaultRoute() {
        return _renderDefaultRoute.apply(this, arguments);
      }

      return renderDefaultRoute;
    }()
  }, {
    key: "matchRoute",
    value: function () {
      var _matchRoute = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2(pathname) {
        var route, _this$config$basename, basename, i, match, params;

        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                debug("Matching location %o", pathname);
                route = null;
                _this$config$basename = this.config.basename, basename = _this$config$basename === void 0 ? "/" : _this$config$basename;

                if (basename !== "/" && pathname.startsWith(basename)) {
                  pathname = pathname.substring(basename.length);
                }

                if (pathname === "") {
                  pathname = "/";
                }

                (0, _sortRoutes.default)(this.routes);
                i = 0;

              case 7:
                if (!(i < this.routes.length)) {
                  _context2.next = 24;
                  break;
                }

                route = (0, _cloneDeep2.default)(this.routes[i]);
                match = (0, _matchPath.default)(pathname, {
                  path: route.path,
                  exact: route.hasOwnProperty("exact") ? route.exact : true
                });

                if (match) {
                  _context2.next = 12;
                  break;
                }

                return _context2.abrupt("continue", 21);

              case 12:
                match.query = _queryString.default.parse(this.history.location.search);
                (0, _parseBoolean.default)(match.query);

                if (route.route) {
                  route = (0, _merge2.default)(route, (0, _find2.default)(this.routes, {
                    name: route.route
                  }));
                }

                this.route = route;
                this.match = match;
                params = {
                  route: route,
                  output: null,
                  match: match
                };
                _context2.next = 20;
                return this.middleware(params);

              case 20:
                return _context2.abrupt("return", params.output);

              case 21:
                i++;
                _context2.next = 7;
                break;

              case 24:
                _context2.next = 26;
                return this.renderDefaultRoute();

              case 26:
                return _context2.abrupt("return", _context2.sent);

              case 27:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function matchRoute(_x) {
        return _matchRoute.apply(this, arguments);
      }

      return matchRoute;
    }()
  }]);
  return Router;
}();

exports.Router = Router;
//# sourceMappingURL=Router.js.map