"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _has2 = _interopRequireDefault(require("lodash/has"));

var _isNil2 = _interopRequireDefault(require("lodash/isNil"));

var _find2 = _interopRequireDefault(require("lodash/find"));

var _pathToRegexp = _interopRequireDefault(require("path-to-regexp"));

var _queryString = _interopRequireDefault(require("query-string"));

var patternCache = {};
var cacheLimit = 10000;
var cacheCount = 0;

var compileGenerator = function compileGenerator(pattern) {
  var cacheKey = pattern;
  var cache = patternCache[cacheKey] || (patternCache[cacheKey] = {});
  if (cache[pattern]) return cache[pattern];

  var compiledGenerator = _pathToRegexp.default.compile(pattern);

  if (cacheCount < cacheLimit) {
    cache[pattern] = compiledGenerator;
    cacheCount++;
  }

  return compiledGenerator;
};
/**
 * Public API for generating a URL pathname from a pattern and parameters.
 */


var generatePath = function generatePath() {
  var pattern = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "/";
  var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  if (pattern === "/") {
    return pattern;
  }

  var generator = compileGenerator(pattern);
  var patternParams = [];
  (0, _pathToRegexp.default)(pattern, patternParams);
  var query = {};
  var paramKeys = Object.keys(params);
  paramKeys.forEach(function (p) {
    if (!(0, _find2.default)(patternParams, {
      name: p
    }) && !(0, _isNil2.default)(params[p]) && params[p] !== "") {
      query[p] = (0, _has2.default)(params[p], "id") ? params[p].id : params[p];
    }
  });

  if ((0, _isEmpty2.default)(query)) {
    return generator(params);
  }

  return generator(params) + "?" + _queryString.default.stringify(query);
};

var _default = generatePath;
exports.default = _default;
//# sourceMappingURL=generatePath.js.map